﻿#pragma once

#include <string>
#include <vector>

class CAuthHeaderParser {
public:
  CAuthHeaderParser(const char* rawHeader);

  bool hasMethod(const char* method) const;
  bool hasParam(const char* name, const char* value = nullptr) const;
  const char* getParam(const char* name) const;
private:
  struct ParamInfo {
    std::string name;
    std::string value;
  };

  std::string _method;
  std::vector<struct ParamInfo> _params;
  
  void parseRawHeader(const std::string& rawHeader);
  void parseParams(const std::string& rawHeader);
  void addParam(const std::string& name, const std::string& value);

  const struct ParamInfo* getParamInfo(const std::string& name) const;
  static std::string unquote(const std::string& str);
};
