﻿#pragma once
#ifndef DESCRIBE_RESPONSE_CHECKER_H
#define DESCRIBE_RESPONSE_CHECKER_H
#include <string>
#include <vector>

#include "UriInfo.h"

class CLiveCapsule;

class CDescribeResponseChecker {
private:
  CLiveCapsule& appFacade;

  bool checkUriFromProperty(const std::string& propertyValue, const std::string& propertyName, const CUriInfo& masterUri);
  bool checkUriFromSdpProperty(const std::vector<std::string>& propertyValues,
    const std::string& attributeName,
    const CUriInfo& masterUri,
    bool (CDescribeResponseChecker::*checkProc)(const std::vector<std::string>& preparsedPropValue, const std::string& attributeName, int ifType));
  bool checkSdpUri(const std::vector<std::string>& preparsedPropValue, const std::string& attributeName, int ifType);
  bool checkSdpInterfaceDescription(const std::vector<std::string>& preparsedPropValue, const std::string& attributeName, int ifType);
  bool checkUriIpAddressType(const std::string& uri, int expectedType, const std::string& refName);
  void assertVerification(bool result, const std::string& message);
  void assertUriVerificationResult(bool result, int expectedType, const std::string& refName);
  void assertIfTypeVerificationResult(bool result, int expectedType, const std::string& refName);
  void assertAddressVerificationResult(bool result, int expectedType, const std::string& refName);
public:
  CDescribeResponseChecker(CLiveCapsule& facade);

  bool CheckSdpResult(const std::string& fullDescribeResponse, const char* sdpMessage);
};
#endif
