﻿#include "RTSPResponseInfo.h"
#include "Strings.h"

CRtspResponseInfo::CRtspResponseInfo(const std::string& responseBody)
{
  responseLines = CStrings::split(responseBody, CStrings::split("\r\n|\n", "|"));
}

std::string CRtspResponseInfo::getRtspProperty(const std::string& propName) const
{
  auto found = CStrings::lookForPropertyValues(responseLines, propName + ": ", 1);
  return found.size() > 0? found[0] : std::string();
}

std::vector<std::string> CRtspResponseInfo::getSdpProperties(const std::string& propName) const
{
  return CStrings::lookForPropertyValues(responseLines, propName);
}

