﻿#include "RtspExtraFields.h"
#include "wrapclient.h"
#include "Strings.h"

std::string RtspExtraFields::composeAllFields(ELiveStep step) const
{
  std::string result = commonField;
  result = mergeFields(result, "\r\n", oneTimeField);
  result = !result.empty() ? CStrings::ensureEndsWith(result, "\r\n") : result;
  return result;
}

std::string RtspExtraFields::composeWithoutCommonFields(ELiveStep step) const
{
  return "";
}

std::string RtspExtraFields::mergeFields(const std::string & leftFields, const std::string & separator, const std::string & rightFields) const
{
  std::string result = leftFields;
  if (!rightFields.empty())
  {
    if (!result.empty())
    {
      if (!CStrings::includes(result, rightFields))
      {
        result += !CStrings::endsWith(result, separator) ? separator : "";
        result += rightFields;
      }
    }
    else
    {
      result = rightFields;
    }
  }
  return result;
}

void RtspExtraFields::setCommonField(const std::string & field)
{
  commonField = field;
}

/*Parameter special meaning: '-' - means to ignore common field for nearest setup extra fields*/
void RtspExtraFields::setOneTimeField(const std::string & field)
{
  oneTimeField = field;
}

void RtspExtraFields::setupRequestFields(CWrapRTSPClient * client, ELiveStep step)
{
  static std::string composedFields;
  composedFields =  (oneTimeField == "-") ? composeWithoutCommonFields(step) : composeAllFields(step);
  client->setCustomFields(composedFields.empty() ? NULL: composedFields.c_str());
  setOneTimeField("");
}
