﻿#pragma once
#ifndef STRINGS_H
#define STRINGS_H
#include <string>
#include <vector>

class CStrings {
public:
  struct NoCaseComparer {
    bool operator() (const std::string& str1, const std::string& str2) const;
  };
  static std::vector<std::string> split(const std::string& str, const std::string& separator);
  static std::vector<std::string> split(const std::string& str, const std::vector<std::string>& separators);
  static std::vector<std::string> lookForPropertyValues(std::vector<std::string> strings, const std::string& startSequence, int maxOccurens = -1);
  static std::vector<std::string> findLinesStartsWith(std::vector<std::string> strings, const std::string& startSequence, int maxOccurens = -1);
  static std::string trim(const std::string& str);
  static std::string trimLeft(const std::string& str);
  static std::string trimRight(const std::string& str);
  static bool includesNoCase(const std::string& str, const std::string& part);
  static bool includes(const std::string& str, const std::string& part);
  static bool equalsNoCase(const std::string& str1, const std::string& str2);
  static std::string::size_type findNoCase(const std::string& str, const std::string& substring);
  static bool startsWithNoCase(const std::string& str, const std::string& substring);
  static bool endsWith(const std::string& str, const std::string& substring);
  static std::string ensureEndsWith(const std::string& str, const std::string& end);
};
#endif
